# Code generated by op-codegen - DO NO EDIT MANUALLY

from .core import _invoke, _invoke_sync
from json import loads
from .iterator import SDKIterator
from .types import GeneratePasswordResponse


class Secrets:
    """
    The Secrets API includes all operations the SDK client can perform on secrets.
    Use secret reference URIs to securely load secrets from 1Password: op://<vault-name>/<item-name>[/<section-name>]/<field-name>
    """

    def __init__(self, client_id):
        self.client_id = client_id

    async def resolve(self, secret_reference):
        """
        Resolve returns the secret the provided secret reference points to.
        """
        response = await _invoke(
            {
                "invocation": {
                    "clientId": self.client_id,
                    "parameters": {
                        "name": "SecretsResolve",
                        "parameters": {"secret_reference": secret_reference},
                    },
                }
            }
        )
        return str(loads(response))

    @staticmethod
    def validate_secret_reference(secret_reference):
        """
        Validate the secret reference to ensure there are no syntax errors.
        """
        _invoke_sync(
            {
                "invocation": {
                    "parameters": {
                        "name": "ValidateSecretReference",
                        "parameters": {"secret_reference": secret_reference},
                    }
                }
            }
        )

    @staticmethod
    def generate_password(recipe):
        response = _invoke_sync(
            {
                "invocation": {
                    "parameters": {
                        "name": "GeneratePassword",
                        "parameters": {"recipe": recipe.model_dump(by_alias=True)},
                    }
                }
            }
        )
        return GeneratePasswordResponse.model_validate_json(response)
